summaryrefslogtreecommitdiff
path: root/contrib/competitions/smt-comp/run-script-smtcomp2014-application
diff options
context:
space:
mode:
Diffstat (limited to 'contrib/competitions/smt-comp/run-script-smtcomp2014-application')
-rwxr-xr-xcontrib/competitions/smt-comp/run-script-smtcomp2014-application52
1 files changed, 52 insertions, 0 deletions
diff --git a/contrib/competitions/smt-comp/run-script-smtcomp2014-application b/contrib/competitions/smt-comp/run-script-smtcomp2014-application
new file mode 100755
index 000000000..53df6a927
--- /dev/null
+++ b/contrib/competitions/smt-comp/run-script-smtcomp2014-application
@@ -0,0 +1,52 @@
+#!/bin/bash
+
+cvc4=./cvc4
+
+read line
+if [ "$line" != '(set-option :print-success true)' ]; then
+ echo 'ERROR: first line supposed to be set-option :print-success, but got: "'"$line"'"' >&2
+ exit 1
+fi
+echo success
+read line
+logic=$(expr "$line" : ' *(set-logic *\([A-Z_]*\) *) *$')
+if [ -z "$logic" ]; then
+ echo 'ERROR: second line supposed to be set-logic, but got: "'"$line"'"' >&2
+ exit 1
+fi
+echo success
+
+function runcvc4 {
+ # we run in this way for line-buffered input, otherwise memory's a
+ # concern (plus it mimics what we'll end up getting from an
+ # application-track trace runner?)
+ $cvc4 --force-logic="$logic" -L smt2 --print-success --no-checking --no-interactive --tear-down-incremental "$@" <&0-
+}
+
+case "$logic" in
+
+QF_LRA)
+ runcvc4 --enable-miplib-trick --miplib-trick-subs=4 --lemmas-on-replay-failure --replay-early-close-depth=4 --replay-lemma-reject-cut=128 --replay-reject-cut=512 --unconstrained-simp
+ ;;
+QF_LIA)
+ # same as QF_LRA but add --pb-rewrites
+ runcvc4 --enable-miplib-trick --miplib-trick-subs=4 --lemmas-on-replay-failure --replay-early-close-depth=4 --replay-lemma-reject-cut=128 --replay-reject-cut=512 --unconstrained-simp --pb-rewrites
+ ;;
+ALIA|AUFLIA|AUFLIRA|AUFNIRA|BV|UF|UFBV|UFIDL|UFLIA|UFLRA|UFNIA)
+ runcvc4 --simplification=none --decision=internal --full-saturate-quant
+ ;;
+LIA|LRA|NIA|NRA)
+ runcvc4 --enable-cbqi --full-saturate-quant
+ ;;
+QF_BV)
+ runcvc4 --unconstrained-simp --bv-eq-slicer=auto --bv-div-zero-const --bv-intro-pow2
+ ;;
+QF_AUFLIA|QF_AX)
+ runcvc4 --no-arrays-eager-index --arrays-eager-lemmas
+ ;;
+*)
+ # just run the default
+ runcvc4
+ ;;
+
+esac
generated by cgit on debian on lair
contact matthew@masot.net with questions or feedback